UNIT level3; { ..६. , 2004}
{  䠩}
INTERFACE
USES common, level1, level2;

PROCEDURE formClusterMap; {ନ஢  ஢}
PROCEDURE putCatRec(n:INTEGER;s:mySector);
{࠭  ⠫   䠩}
PROCEDURE writeMyFile(fn:STRING;mf:myFile); { 䠩}
PROCEDURE writeVirtualDisk(fn:STRING);
{࠭ ࠧ 㠫쭮 ᪠}
PROCEDURE readVirtualDisk(fn:STRING);
{ ࠧ 㠫쭮 ᪠}
FUNCTION  readMyFile(fn:STRING):myFile; { 䠩}
FUNCTION  getCatRec(n:INTEGER):mySector; {  ⠫}
TYPE sName=STRING[cat_nam];
FUNCTION  getCatName(n:INTEGER):sName;  {    䠩}
FUNCTION  getCatLen(n:INTEGER):INTEGER; { }
FUNCTION  getCatCluster(n,k:INTEGER):INTEGER; {  }
FUNCTION  fileID(fn:STRING;print:BOOLEAN):INTEGER;
{। 䨪 () 䠩   }

IMPLEMENTATION
(* DIRECTORY *)
FUNCTION  getCatRec(n:INTEGER):mySector; {  ⠫}
BEGIN getCatRec:=sectors[n]
END;

FUNCTION getCatName(n:INTEGER):sName; {    䠩}
BEGIN getCatName:=COPY(getCatRec(n),1,cat_nam)
END;

FUNCTION getCatLen(n:INTEGER):INTEGER; { }
VAR l,e:INTEGER;
BEGIN getCatLen:=-1;
      val(COPY(getCatRec(n),cat_len,2),l,e);{८ࠧ  ᫮}
      IF e<>0 THEN WRITELN('incorrect file length')
              ELSE getCatLen:=l
END;

FUNCTION getCatCluster(n,k:INTEGER):INTEGER; {  }
{n - file ID, k - cluster number in file (1..fs_ml)}
VAR w:STRING; i,e:INTEGER;
BEGIN VAL(COPY(getCatRec(n),cat_cl0+2*(k-1),2),i,e);
      IF e=0 THEN getCatCluster:=i
             ELSE getCatCluster:=-1
END;

PROCEDURE putCatRec(n:INTEGER;s:mySector);
{࠭  ⠫   䠩}
BEGIN sectors[n]:=s
END;

FUNCTION fileID(fn:STRING;print:BOOLEAN):INTEGER;
{। 䨪 () 䠩   }
VAR i:INTEGER;
BEGIN fileID:=-1; i:=0;
      WHILE (i<fs_mnf) AND (fn<>getCatName(i))
            DO i:=i+1; {饬 ᮢ}
      IF i<fs_mnf
         THEN fileID:=i
         ELSE IF print THEN WRITELN(' "'+fn+'"  ')
END;

(* CLUSTER MAP *)
PROCEDURE formClusterMap;
{ନ஢  ஢}
VAR i,k,w:INTEGER; s:STRING;
BEGIN FOR i:=0 TO (dsk_ns DIV fs_spc)-1 DO clusterMap[i]:=0;{⪠}
      FOR i:=0 TO fs_mnf-1 DO {横  ᥬ 䠩}
          BEGIN s:=getCatName(i);
                IF s[1]<>pusto THEN {᫨ 䠩 }
                   BEGIN FOR k:=1 TO fs_ml DO {横  ࠬ}
                         BEGIN w:=getCatCluster(i,k);
                               IF w<>-1 THEN clusterMap[w]:=1;
                         END
                   END
          END;
END;

FUNCTION nextCluster:INTEGER;
{  ஢: 頥  ࢮ ⮣
  砥   }
VAR i,l:INTEGER;
BEGIN nextCluster:=-1; l:=dsk_ns DIV fs_spc;{᫮ ஢}
      i:=0;
      WHILE (i<l) AND (clusterMap[i]<>0) {饬 ⮩ }
            DO i:=i+1;
      IF i<l THEN BEGIN nextCluster:=i; clusterMap[i]:=1 END
             ELSE WRITELN('   ᪥!')
END;

(* FILES *)
FUNCTION readMyFile(fn:STRING):myFile; { 䠩}
VAR id,j,w:INTEGER; mf:myFile;
BEGIN id:=fileID(fn,true); IF id<0 THEN EXIT;
      mf:='';
      FOR j:=1 TO fs_ml DO {  }
          BEGIN w:=getCatCluster(id,j);
                IF w<>-1 { }
                   THEN mf:=mf+getCluster(w); { ᮤন}
          END;
      w:=getCatLen(id); {file length} mf:=COPY(mf,1,w);
      readMyFile:=mf
END;

PROCEDURE writeMyFile(fn:STRING;mf:myFile); { 䠩}
VAR cat,w:STRING; l,i,k,cs,n:INTEGER;
    PROCEDURE addToCat(i:integer);
    {   ⠫ ࠧ來 筮 楫}
    BEGIN STR(i,w); IF i<10 THEN w:='0'+w; cat:=cat+w;
    END;
BEGIN WHILE LENGTH(fn)<cat_nam
            DO fn:=fn+' '; { ஡ ⪮ }
      IF LENGTH(fn)>cat_nam
         THEN fn:=COPY(fn,1,cat_nam); {᫨ ᫨誮  }
      cat:=fn; {砫 ନ஢   ⠫}
      l:=LENGTH(mf); { 䠩; ⠥,  <100}
      addToCat(l);   {   . }
      cs:=dsk_bps*fs_spc; {ࠧ   }
      k:=(l-1) div cs + 1;{⢮ ஢  䠩}
      FOR i:=1 TO k DO { ஢}
          BEGIN n:=nextCluster; addToCat(n);{  . }
                w:=COPY(mf,1,cs); {ᮤন । }
                DELETE(mf,1,cs);  { ,  襬}
                WHILE LENGTH(w)<cs DO w:=w+pusto; {  cs}
                putCluster(n,w);  {࠭塞  䠩}
          END;
      WHILE LENGTH(cat)<dsk_bps DO cat:=cat+'-';{᫨ ஢ }
      i:=0; {饬 ⮥   ⠫  ᨬ ଠ  䠩}
      WHILE (i<fs_mnf) AND (COPY(getCatRec(i),1,1)<>pusto) DO i:=i+1;
      IF i<fs_mnf THEN putCatRec(i,cat)
                  ELSE WRITELN('Too many files!');
END;

(* VIRTUAL DISK *)
PROCEDURE readVirtualDisk(fn:STRING);
{ ࠧ 㠫쭮 ᪠}
BEGIN fromDisk(fn); formClusterMap;
END;

PROCEDURE writeVirtualDisk(fn:STRING);
{࠭ ࠧ 㠫쭮 ᪠}
BEGIN toDisk(fn);
END;

END.
